commit 5c8c470ff389fb8e049be416b1e7382e5f62dfc7
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Tue Mar 3 16:27:59 2020 +0100

    README.md further enhanced

diff --git a/README.md b/README.md
index e96bb26..4309314 100644
--- a/README.md
+++ b/README.md
@@ -51,29 +51,31 @@ Contents
     5.  GNU ARM Embedded Toolchain
     6.  CMake
 2.  Recommended Software
+    1.  PlantUML
+    2.  QtCreator IDE
 3.  Compiling the Source Code
     1.  Host Software
     2.  Target Software
 
 --------------------------------------------------------------------------------
 
-1   Required Software
-=====================
+1 Required Software
+===================
 
 In order to compile and flash the AMiRo bootloader, some additional software is
 required, all of which are described in detail in the following.
 
 
-1.1   Git
----------
+1.1 Git
+-------
 
 Since all main- and subprojects are available as Git repositories, installing a
 recent version of the tool is mandatory. Most Linux distributions like Ubuntu
 provide a sufficient version in their software repositories.
 
 
-1.2   GNU Make
---------------
+1.2 GNU Make
+------------
 
 GNU Make usually comes as preinstalled tool on Ubuntu based operating systems.
 If your system is missing GNU Make, it is recommended to install it from the
@@ -81,8 +83,8 @@ standard repositories since no special requirements (i.e. features of a very
 recent version) are required.
 
 
-1.3   GCC
----------
+1.3 GCC
+-------
 
 In order to build some required tools from source, GCC is required. It usually
 comes as preinstalled tool on Ubuntu based operating systems. If your system is
@@ -91,8 +93,8 @@ since no special requirements (e.g. features of a very recent version) are
 required.
 
 
-1.4   stm32flash
-----------------
+1.4 stm32flash
+--------------
 
 This tool is required to flash the bootloader binaries to the microcontrollers
 of the AMiRo base modules. Since it is included in this project as a Git
@@ -110,8 +112,8 @@ this usually requires root permissions. However, `stm32flash` provides a
 the file `./Host/Source/stm32flash/INSTALL`.
 
 
-1.5   GNU ARM Embedded Toolchain
---------------------------------
+1.5 GNU ARM Embedded Toolchain
+------------------------------
 
 Various versions of the GCC for ARM embedded devices can be found at
 <https://developer.arm.com/open-source/gnu-toolchain/gnu-rm> (old versions are
@@ -131,8 +133,8 @@ several 32-bit libraries. The required packages are `libc6`, `libstdc++6`, and
     >$ sudo apt-get install libc6:i386 libstdc++6:i386 libncurses5:i386
 
 
-1.6   CMake
------------
+1.6 CMake
+---------
 
 In order to build the `SerialBoot` host application, `CMake` version 2.8 or
 later is required. If possible, it is recommended to instal it from the standard
@@ -140,18 +142,36 @@ repositories of your operating system.
 
 
 
-2   Recommended Software
-========================
+2 Recommended Software
+======================
+
+The software tools named in this section are not essential for simply using or
+further development of AMiRo-BLT, but can help for both scenarios.
+
+
+2.1 PlantUML
+------------
+
+PlantUML is a free and open source Java tool to generate UML diagrams via scrips
+(see <https://plantuml.com>). AMiRo-BLT provides according scripts in the
+`./Target/Doc/` directory. Please refer to the PlantUML documentation for how to
+generate figures from these script files.
+
+
+2.2 QtCreator IDE
+-----------------
 
 AMiRo-BLT provides support for the QtCreator IDE. In order to setup according
 projects, use the setup script and follow the instructions. It will
 automatically generate the required files and you can import the projects by
-opening the `.creator` files with QtCreator IDE.
+opening the `.creator` files with QtCreator IDE.  
+Please note that you will need to recompile the AMiRo-OS source code after each
+project generation, since the generator runs a compiler call.
 
 
 
-3   Compiling the Source Code
-=============================
+3 Compiling the Source Code
+===========================
 
 The AMiRo-BLT project is separated into two major parts: target- and host-
 related software. The former comprises the bootloaders for the three base
@@ -163,8 +183,8 @@ module is the only one accessible when the robot is fully set up, this enables
 to update the firmware even for other modules.
 
 
-3.1   Host Software
--------------------
+3.1 Host Software
+-----------------
 
 The `stm32flash` tool is requried to flash bootloader binaries to the MCUs.
 Instructions for builing the tool are given in chapter 1.4 of this file.
@@ -177,8 +197,8 @@ the binary path should be `./Host/Source/SerialBoot/build/SerialBoot`, which is
 the default for any scripts and tools that use `SerialBoot`.
 
 
-3.2   Target Software
----------------------
+3.2 Target Software
+-------------------
 
 Module specific code for the several AMiRo base modules is located in the
 individual subfolders in the `./Target/Modules/` directory. To compile
@@ -223,5 +243,5 @@ If the procedure was not successful, the following hints might help:
     Keep a charger plugged in during flashing.
 
 **Attention**: Never flash a bootloader to the wrong module! Doing so might
-cause severe errors and damage the robot.
+cause severe errors and damage the hardware.
 