commit f606f432933384278331ec7a083bf3a7f01f1adc
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Tue Oct 15 15:05:44 2019 +0200

    Introduced a new (preliminary) test for the new DW1000v2 driver (WIP!).

diff --git a/modules/LightRing_1-2/module.c b/modules/LightRing_1-2/module.c
index 801e533..b763077 100644
--- a/modules/LightRing_1-2/module.c
+++ b/modules/LightRing_1-2/module.c
@@ -69,9 +69,8 @@ SPIConfig moduleHalSpiLightConfig = {
   /* CR2                         */ SPI_CR2_RXDMAEN | SPI_CR2_TXDMAEN,
 };
 
-#if (BOARD_DW1000_CONNECTED == true)
+#if (BOARD_BREAKOUT_MODULE == BOARD_BREAKOUT_UWBv10)
 
-/*! SPI (high speed) configuration for DW1000 */
 SPIConfig moduleHalSpiUwbHsConfig = {
   /* circular buffer mode        */ false,
   /* callback function pointer   */ NULL,
@@ -80,7 +79,7 @@ SPIConfig moduleHalSpiUwbHsConfig = {
   /* CR1                         */ 0,                                  // 36/2 Mbps
   /* CR2                         */ SPI_CR2_RXDMAEN | SPI_CR2_TXDMAEN,  // 0
 };
-/*! SPI (low speed) configuration for DW1000 */
+
 SPIConfig moduleHalSpiUwbLsConfig = {
   /* circular buffer mode        */ false,
   /* callback function pointer   */ NULL,
@@ -90,8 +89,7 @@ SPIConfig moduleHalSpiUwbLsConfig = {
   /* CR2                         */ SPI_CR2_RXDMAEN | SPI_CR2_TXDMAEN,  // 0
 };
 
-#endif /* BOARD_DW1000_CONNECTED == true */
-
+#endif /* (BOARD_BREAKOUT_MODULE == BOARD_BREAKOUT_UWBv10) */
 
 /*===========================================================================*/
 /**
@@ -177,139 +175,165 @@ ROMCONST apalControlGpio_t moduleGpioSwV50En = {
 };
 
 /**
- * @brief   IO_3 breakout signal GPIO.
+ * @brief   SYS_UART_DN bidirectional signal GPIO.
  */
-static apalGpio_t _gpioBreakoutIo3 = {
-  /* line */ LINE_IO_3,
+static apalGpio_t _gpioSysUartDn = {
+  /* line */ LINE_SYS_UART_DN,
 };
-apalControlGpio_t moduleGpioBreakoutIo3 = {
-  /* GPIO */ &_gpioBreakoutIo3,
+ROMCONST apalControlGpio_t moduleGpioSysUartDn = {
+  /* GPIO */ &_gpioSysUartDn,
   /* meta */ {
-    /* direction      */ APAL_GPIO_DIRECTION_UNDEFINED,
+    /* direction      */ APAL_GPIO_DIRECTION_BIDIRECTIONAL,
     /* active state   */ APAL_GPIO_ACTIVE_LOW,
-    /* interrupt edge */ APAL_GPIO_EDGE_NONE,
+    /* interrupt edge */ APAL_GPIO_EDGE_BOTH,
   },
 };
 
 /**
- * @brief   IO_5 breakout signal GPIO.
+ * @brief   LED output signal GPIO.
  */
-static apalGpio_t _gpioBreakoutIo5 = {
-  /* line */ LINE_IO_5,
+static apalGpio_t _gpioLed = {
+  /* line */ LINE_LED,
 };
-apalControlGpio_t moduleGpioBreakoutIo5 = {
-  /* GPIO */ &_gpioBreakoutIo5,
+ROMCONST apalControlGpio_t moduleGpioLed = {
+  /* GPIO */ &_gpioLed,
   /* meta */ {
-    /* direction      */ APAL_GPIO_DIRECTION_UNDEFINED,
+    /* direction      */ APAL_GPIO_DIRECTION_OUTPUT,
     /* active state   */ APAL_GPIO_ACTIVE_LOW,
     /* interrupt edge */ APAL_GPIO_EDGE_NONE,
   },
 };
 
 /**
- * @brief   IO_6 breakout signal GPIO.
+ * @brief   LIGHT_XLAT output signal GPIO.
  */
-static apalGpio_t _gpioBreakoutIo6 = {
-  /* line */ LINE_IO_6,
+static apalGpio_t _gpioLightXlat = {
+  /* line */ LINE_LIGHT_XLAT,
 };
-apalControlGpio_t moduleGpioBreakoutIo6 = {
-  /* GPIO */ &_gpioBreakoutIo6,
+ROMCONST apalControlGpio_t moduleGpioLightXlat = {
+  /* GPIO */ &_gpioLightXlat,
   /* meta */ {
-    /* direction      */ APAL_GPIO_DIRECTION_UNDEFINED,
-    /* active state   */ APAL_GPIO_ACTIVE_LOW,
+    /* direction      */ APAL_GPIO_DIRECTION_OUTPUT,
+    /* active state   */ (TLC5947_LLD_XLAT_UPDATE_EDGE == APAL_GPIO_EDGE_RISING) ? APAL_GPIO_ACTIVE_HIGH : APAL_GPIO_ACTIVE_LOW,
     /* interrupt edge */ APAL_GPIO_EDGE_NONE,
   },
 };
 
 /**
- * @brief   SYS_UART_DN bidirectional signal GPIO.
+ * @brief   SW_V18_EN output signal GPIO.
  */
-static apalGpio_t _gpioSysUartDn = {
-  /* line */ LINE_SYS_UART_DN,
+static apalGpio_t _gpioSwV18En = {
+  /* line */ LINE_SW_V18_EN,
 };
-ROMCONST apalControlGpio_t moduleGpioSysUartDn = {
-  /* GPIO */ &_gpioSysUartDn,
+ROMCONST apalControlGpio_t moduleGpioSwV18En = {
+  /* GPIO */ &_gpioSwV18En,
   /* meta */ {
-    /* direction      */ APAL_GPIO_DIRECTION_BIDIRECTIONAL,
-    /* active state   */ APAL_GPIO_ACTIVE_LOW,
-    /* interrupt edge */ APAL_GPIO_EDGE_BOTH,
+    /* direction      */ APAL_GPIO_DIRECTION_OUTPUT,
+    /* active state   */ MIC9404x_LLD_EN_ACTIVE_STATE,
+    /* interrupt edge */ APAL_GPIO_EDGE_NONE,
   },
 };
 
-#if (BOARD_DW1000_CONNECTED == true)
 /**
- * @brief   DW1000 interrrupt input signal GPIO.
+ * @brief   SW_VSYS_EN output signal GPIO.
  */
-static apalGpio_t _gpioDw1000Irqn = {
-  /* line */  LINE_IO_8,            // (GPIOB, GPIOB_IO_8),
+static apalGpio_t _gpioSwVsysEn = {
+  /* line */ LINE_SW_VSYS_EN,
 };
-ROMCONST apalControlGpio_t moduleGpioDw1000Irqn = {
-  /* GPIO */ &_gpioDw1000Irqn,
+ROMCONST apalControlGpio_t moduleGpioSwVsysEn = {
+  /* GPIO */ &_gpioSwVsysEn,
   /* meta */ {
-    /* direction      */ APAL_GPIO_DIRECTION_INPUT,
-    /* active state   */ APAL_GPIO_ACTIVE_LOW,
-    /* interrupt edge */ APAL_GPIO_EDGE_RISING,
+    /* direction      */ APAL_GPIO_DIRECTION_OUTPUT,
+    /* active state   */ APAL_GPIO_ACTIVE_HIGH,
+    /* interrupt edge */ APAL_GPIO_EDGE_NONE,
   },
 };
 
 /**
- * @brief   DW1000 reset output signal GPIO.
+ * @brief   SYS_UART_UP bidirectional signal GPIO.
  */
-static apalGpio_t _gpioDw1000Reset = {
-  /* line */ LINE_IO_7,
+static apalGpio_t _gpioSysUartUp = {
+  /* line */ LINE_SYS_UART_UP,
 };
-ROMCONST apalControlGpio_t moduleGpioDw1000Reset = {
-  /* GPIO */ &_gpioDw1000Reset,
+ROMCONST apalControlGpio_t moduleGpioSysUartUp = {
+  /* GPIO */ &_gpioSysUartUp,
   /* meta */ {
     /* direction      */ APAL_GPIO_DIRECTION_BIDIRECTIONAL,
     /* active state   */ APAL_GPIO_ACTIVE_LOW,
-    /* interrupt edge */ APAL_GPIO_EDGE_NONE,
+    /* interrupt edge */ APAL_GPIO_EDGE_BOTH,
   },
 };
 
 /**
- * @brief   IO_2 breakout signal GPIO.
+ * @brief   SYS_PD bidirectional signal GPIO.
  */
-static apalGpio_t _gpioDw1000WakeUp = {
-  /* line */ LINE_IO_2,
+static apalGpio_t _gpioSysPd = {
+  /* line */ LINE_SYS_PD_N,
 };
-ROMCONST apalControlGpio_t moduleGpioDw1000WakeUp = {
-  /* GPIO */ &_gpioDw1000WakeUp,
+ROMCONST apalControlGpio_t moduleGpioSysPd = {
+  /* GPIO */ &_gpioSysPd,
   /* meta */ {
-    /* direction      */ APAL_GPIO_DIRECTION_OUTPUT,
-    /* active state   */ APAL_GPIO_ACTIVE_HIGH,
-    /* interrupt edge */ APAL_GPIO_EDGE_NONE,
+    /* direction      */ APAL_GPIO_DIRECTION_BIDIRECTIONAL,
+    /* active state   */ APAL_GPIO_ACTIVE_LOW,
+    /* interrupt edge */ APAL_GPIO_EDGE_BOTH,
   },
 };
 
 /**
- * @brief   DW1000 SPI chip select output signal GPIO.
+ * @brief   SYS_SYNC bidirectional signal GPIO.
  */
-static apalGpio_t _gpioSpiChipSelect = {
-  /* line */ LINE_SPI_SS_N,
+static apalGpio_t _gpioSysSync = {
+  /* line */ LINE_SYS_INT_N,
 };
-ROMCONST apalControlGpio_t moduleGpioSpiChipSelect = {
-  /* GPIO */ &_gpioSpiChipSelect,
+ROMCONST apalControlGpio_t moduleGpioSysSync = {
+  /* GPIO */ &_gpioSysSync,
   /* meta */ {
-    /* direction      */ APAL_GPIO_DIRECTION_OUTPUT,
+    /* direction      */ APAL_GPIO_DIRECTION_BIDIRECTIONAL,
     /* active state   */ APAL_GPIO_ACTIVE_LOW,
-    /* interrupt edge */ APAL_GPIO_EDGE_NONE,
+    /* interrupt edge */ APAL_GPIO_EDGE_BOTH,
   },
 };
-#else
+
 /**
- * @brief   IO_8 breakout signal GPIO.
+ * @brief   IO_1 breakout signal GPIO.
  */
-static apalGpio_t _gpioBreakoutIo8 = {
-  /* line */ LINE_IO_8,
+static apalGpio_t _gpioBreakoutIo1 = {
+  /* line */ LINE_IO_1,
 };
-apalControlGpio_t moduleGpioBreakoutIo8 = {
-  /* GPIO */ &_gpioBreakoutIo8,
-  /* meta */ {
-    /* direction      */ APAL_GPIO_DIRECTION_UNDEFINED,
-    /* active state   */ APAL_GPIO_ACTIVE_LOW,
-    /* interrupt edge */ APAL_GPIO_EDGE_NONE,
-  },
+
+/**
+ * @brief   IO_2 breakout signal GPIO.
+ */
+static apalGpio_t _gpioBreakoutIo2 = {
+  /* line */ LINE_IO_2,
+};
+
+/**
+ * @brief   IO_3 breakout signal GPIO.
+ */
+static apalGpio_t _gpioBreakoutIo3 = {
+  /* line */ LINE_IO_3,
+};
+
+/**
+ * @brief   IO_4 breakout signal GPIO.
+ */
+static apalGpio_t _gpioBreakoutIo4 = {
+  /* line */ LINE_IO_4,
+};
+
+/**
+ * @brief   IO_5 breakout signal GPIO.
+ */
+static apalGpio_t _gpioBreakoutIo5 = {
+  /* line */ LINE_IO_5,
+};
+
+/**
+ * @brief   IO_6 breakout signal GPIO.
+ */
+static apalGpio_t _gpioBreakoutIo6 = {
+  /* line */ LINE_IO_6,
 };
 
 /**
@@ -318,116 +342,101 @@ apalControlGpio_t moduleGpioBreakoutIo8 = {
 static apalGpio_t _gpioBreakoutIo7 = {
   /* line */ LINE_IO_7,
 };
-apalControlGpio_t moduleGpioBreakoutIo7 = {
-  /* GPIO */ &_gpioBreakoutIo7,
+
+/**
+ * @brief   IO_8 breakout signal GPIO.
+ */
+static apalGpio_t _gpioBreakoutIo8 = {
+  /* line */ LINE_IO_8,
+};
+
+#if (BOARD_BREAKOUT_MODULE == BOARD_BREAKOUT_NONE)
+
+apalControlGpio_t moduleGpioBreakoutIo1 = {
+  /* GPIO */ &_gpioBreakoutIo1,
   /* meta */ {
     /* direction      */ APAL_GPIO_DIRECTION_UNDEFINED,
-    /* active state   */ APAL_GPIO_ACTIVE_LOW,
+    /* active state   */ APAL_GPIO_ACTIVE_NONE,
     /* interrupt edge */ APAL_GPIO_EDGE_NONE,
   },
 };
 
-/**
- * @brief   IO_2 breakout signal GPIO.
- */
-static apalGpio_t _gpioBreakoutIo2 = {
-  /* line */ LINE_IO_2,
-};
 apalControlGpio_t moduleGpioBreakoutIo2 = {
   /* GPIO */ &_gpioBreakoutIo2,
   /* meta */ {
     /* direction      */ APAL_GPIO_DIRECTION_UNDEFINED,
-    /* active state   */ APAL_GPIO_ACTIVE_LOW,
+    /* active state   */ APAL_GPIO_ACTIVE_NONE,
     /* interrupt edge */ APAL_GPIO_EDGE_NONE,
   },
 };
-#endif  /* BOARD_DW1000_CONNECTED == true */
 
-
-/**
- * @brief   IO_4 breakout signal GPIO.
- */
-static apalGpio_t _gpioBreakoutIo4 = {
-  /* line */ LINE_IO_4,
+apalControlGpio_t moduleGpioBreakoutIo3 = {
+  /* GPIO */ &_gpioBreakoutIo3,
+  /* meta */ {
+    /* direction      */ APAL_GPIO_DIRECTION_UNDEFINED,
+    /* active state   */ APAL_GPIO_ACTIVE_NONE,
+    /* interrupt edge */ APAL_GPIO_EDGE_NONE,
+  },
 };
+
 apalControlGpio_t moduleGpioBreakoutIo4 = {
   /* GPIO */ &_gpioBreakoutIo4,
   /* meta */ {
     /* direction      */ APAL_GPIO_DIRECTION_UNDEFINED,
-    /* active state   */ APAL_GPIO_ACTIVE_LOW,
+    /* active state   */ APAL_GPIO_ACTIVE_NONE,
     /* interrupt edge */ APAL_GPIO_EDGE_NONE,
   },
 };
 
-/**
- * @brief   IO_1 breakout signal GPIO.
- */
-static apalGpio_t _gpioBreakoutIo1 = {
-  /* line */ LINE_IO_1,
-};
-apalControlGpio_t moduleGpioBreakoutIo1 = {
-  /* GPIO */ &_gpioBreakoutIo1,
+apalControlGpio_t moduleGpioBreakoutIo5 = {
+  /* GPIO */ &_gpioBreakoutIo5,
   /* meta */ {
     /* direction      */ APAL_GPIO_DIRECTION_UNDEFINED,
-    /* active state   */ APAL_GPIO_ACTIVE_LOW,
+    /* active state   */ APAL_GPIO_ACTIVE_NONE,
     /* interrupt edge */ APAL_GPIO_EDGE_NONE,
   },
 };
 
-
-/**
- * @brief   LED output signal GPIO.
- */
-static apalGpio_t _gpioLed = {
-  /* line */ LINE_LED,
-};
-ROMCONST apalControlGpio_t moduleGpioLed = {
-  /* GPIO */ &_gpioLed,
+apalControlGpio_t moduleGpioBreakoutIo6 = {
+  /* GPIO */ &_gpioBreakoutIo6,
   /* meta */ {
-    /* direction      */ APAL_GPIO_DIRECTION_OUTPUT,
-    /* active state   */ APAL_GPIO_ACTIVE_LOW,
+    /* direction      */ APAL_GPIO_DIRECTION_UNDEFINED,
+    /* active state   */ APAL_GPIO_ACTIVE_NONE,
     /* interrupt edge */ APAL_GPIO_EDGE_NONE,
   },
 };
 
-/**
- * @brief   LIGHT_XLAT output signal GPIO.
- */
-static apalGpio_t _gpioLightXlat = {
-  /* line */ LINE_LIGHT_XLAT,
-};
-ROMCONST apalControlGpio_t moduleGpioLightXlat = {
-  /* GPIO */ &_gpioLightXlat,
+apalControlGpio_t moduleGpioBreakoutIo7 = {
+  /* GPIO */ &_gpioBreakoutIo7,
   /* meta */ {
-    /* direction      */ APAL_GPIO_DIRECTION_OUTPUT,
-    /* active state   */ (TLC5947_LLD_XLAT_UPDATE_EDGE == APAL_GPIO_EDGE_RISING) ? APAL_GPIO_ACTIVE_HIGH : APAL_GPIO_ACTIVE_LOW,
+    /* direction      */ APAL_GPIO_DIRECTION_UNDEFINED,
+    /* active state   */ APAL_GPIO_ACTIVE_NONE,
     /* interrupt edge */ APAL_GPIO_EDGE_NONE,
   },
 };
 
-/**
- * @brief   SW_V18_EN output signal GPIO.
- */
-static apalGpio_t _gpioSwV18En = {
-  /* line */ LINE_SW_V18_EN,
-};
-ROMCONST apalControlGpio_t moduleGpioSwV18En = {
-  /* GPIO */ &_gpioSwV18En,
+apalControlGpio_t moduleGpioBreakoutIo8 = {
+  /* GPIO */ &_gpioBreakoutIo8,
   /* meta */ {
-    /* direction      */ APAL_GPIO_DIRECTION_OUTPUT,
-    /* active state   */ MIC9404x_LLD_EN_ACTIVE_STATE,
+    /* direction      */ APAL_GPIO_DIRECTION_UNDEFINED,
+    /* active state   */ APAL_GPIO_ACTIVE_NONE,
     /* interrupt edge */ APAL_GPIO_EDGE_NONE,
   },
 };
 
-/**
- * @brief   SW_VSYS_EN output signal GPIO.
- */
-static apalGpio_t _gpioSwVsysEn = {
-  /* line */ LINE_SW_VSYS_EN,
+#elif (BOARD_BREAKOUT_MODULE == BOARD_BREAKOUT_UWBv10)
+
+apalControlGpio_t moduleGpioBreakoutIo1 = {
+  /* GPIO */ &_gpioBreakoutIo1,
+  /* meta */ {
+    /* direction      */ APAL_GPIO_DIRECTION_UNDEFINED,
+    /* active state   */ APAL_GPIO_ACTIVE_NONE,
+    /* interrupt edge */ APAL_GPIO_EDGE_NONE,
+  },
 };
-ROMCONST apalControlGpio_t moduleGpioSwVsysEn = {
-  /* GPIO */ &_gpioSwVsysEn,
+
+apalControlGpio_t moduleGpioBreakoutIo2 = {
+  /* GPIO */ &_gpioBreakoutIo2,
   /* meta */ {
     /* direction      */ APAL_GPIO_DIRECTION_OUTPUT,
     /* active state   */ APAL_GPIO_ACTIVE_HIGH,
@@ -435,51 +444,62 @@ ROMCONST apalControlGpio_t moduleGpioSwVsysEn = {
   },
 };
 
-/**
- * @brief   SYS_UART_UP bidirectional signal GPIO.
- */
-static apalGpio_t _gpioSysUartUp = {
-  /* line */ LINE_SYS_UART_UP,
+apalControlGpio_t moduleGpioBreakoutIo3 = {
+  /* GPIO */ &_gpioBreakoutIo3,
+  /* meta */ {
+    /* direction      */ APAL_GPIO_DIRECTION_UNDEFINED,
+    /* active state   */ APAL_GPIO_ACTIVE_NONE,
+    /* interrupt edge */ APAL_GPIO_EDGE_NONE,
+  },
 };
-ROMCONST apalControlGpio_t moduleGpioSysUartUp = {
-  /* GPIO */ &_gpioSysUartUp,
+
+apalControlGpio_t moduleGpioBreakoutIo4 = {
+  /* GPIO */ &_gpioBreakoutIo4,
   /* meta */ {
-    /* direction      */ APAL_GPIO_DIRECTION_BIDIRECTIONAL,
-    /* active state   */ APAL_GPIO_ACTIVE_LOW,
-    /* interrupt edge */ APAL_GPIO_EDGE_BOTH,
+    /* direction      */ APAL_GPIO_DIRECTION_UNDEFINED,
+    /* active state   */ APAL_GPIO_ACTIVE_NONE,
+    /* interrupt edge */ APAL_GPIO_EDGE_NONE,
   },
 };
 
-/**
- * @brief   SYS_PD bidirectional signal GPIO.
- */
-static apalGpio_t _gpioSysPd = {
-  /* line */ LINE_SYS_PD_N,
+apalControlGpio_t moduleGpioBreakoutIo5 = {
+  /* GPIO */ &_gpioBreakoutIo5,
+  /* meta */ {
+    /* direction      */ APAL_GPIO_DIRECTION_UNDEFINED,
+    /* active state   */ APAL_GPIO_ACTIVE_NONE,
+    /* interrupt edge */ APAL_GPIO_EDGE_NONE,
+  },
 };
-ROMCONST apalControlGpio_t moduleGpioSysPd = {
-  /* GPIO */ &_gpioSysPd,
+
+apalControlGpio_t moduleGpioBreakoutIo6 = {
+  /* GPIO */ &_gpioBreakoutIo6,
+  /* meta */ {
+    /* direction      */ APAL_GPIO_DIRECTION_UNDEFINED,
+    /* active state   */ APAL_GPIO_ACTIVE_NONE,
+    /* interrupt edge */ APAL_GPIO_EDGE_NONE,
+  },
+};
+
+apalControlGpio_t moduleGpioBreakoutIo7 = {
+  /* GPIO */ &_gpioBreakoutIo7,
   /* meta */ {
     /* direction      */ APAL_GPIO_DIRECTION_BIDIRECTIONAL,
     /* active state   */ APAL_GPIO_ACTIVE_LOW,
-    /* interrupt edge */ APAL_GPIO_EDGE_BOTH,
+    /* interrupt edge */ APAL_GPIO_EDGE_NONE,
   },
 };
 
-/**
- * @brief   SYS_SYNC bidirectional signal GPIO.
- */
-static apalGpio_t _gpioSysSync = {
-  /* line */ LINE_SYS_INT_N,
-};
-ROMCONST apalControlGpio_t moduleGpioSysSync = {
-  /* GPIO */ &_gpioSysSync,
+apalControlGpio_t moduleGpioBreakoutIo8 = {
+  /* GPIO */ &_gpioBreakoutIo8,
   /* meta */ {
-    /* direction      */ APAL_GPIO_DIRECTION_BIDIRECTIONAL,
+    /* direction      */ APAL_GPIO_DIRECTION_INPUT,
     /* active state   */ APAL_GPIO_ACTIVE_LOW,
-    /* interrupt edge */ APAL_GPIO_EDGE_BOTH,
+    /* interrupt edge */ APAL_GPIO_EDGE_RISING,
   },
 };
 
+#endif
+
 /** @} */
 
 /*===========================================================================*/
@@ -506,72 +526,6 @@ ROMCONST char* moduleShellPrompt = "LightRing";
 
 /*===========================================================================*/
 /**
- * @name Hardware specific wrappers Functions
- * @{
- */
-/*===========================================================================*/
-
-#if (BOARD_DW1000_CONNECTED == true)
-/*! @brief Manually reset the DW1000 module  */
-void reset_DW1000(void){
-
-  // Set the pin as output
-  palSetLineMode(moduleGpioDw1000Reset.gpio->line, APAL_GPIO_DIRECTION_OUTPUT);
-
-  //drive the RSTn pin low
-  apalGpioWrite(moduleGpioDw1000Reset.gpio, APAL_GPIO_LOW);
-
-  //put the pin back to tri-state ... as input
-//  palSetLineMode(moduleGpioDw1000Reset.gpio->line, APAL_GPIO_DIRECTION_INPUT); // TODO:
-
-  aosThdMSleep(2);
-}
-
-/*! @brief entry point to the IRQn event in DW1000 module
- *
- * */
-void process_deca_irq(void){
-  do{
-    dwt_isr();
-   //while IRS line active (ARM can only do edge sensitive interrupts)
-  }while(port_CheckEXT_IRQ() == 1);
-}
-
-/*! @brief Check the current value of GPIO pin and return the value */
-apalGpioState_t port_CheckEXT_IRQ(void) {
-  apalGpioState_t  val;
-  apalGpioRead(moduleGpioDw1000Irqn.gpio, &val);
-  return val;
-}
-
-/*! @brief Manually set the chip select pin of the SPI */
-void set_SPI_chip_select(void){
-  apalGpioWrite(moduleGpioSpiChipSelect.gpio, APAL_GPIO_HIGH);
-}
-
-/*! @brief Manually reset the chip select pin of the SPI */
-void clear_SPI_chip_select(void){
-  apalGpioWrite(moduleGpioSpiChipSelect.gpio, APAL_GPIO_LOW);
-}
-
-/*! @brief Change the SPI speed configuration on the fly */
-void setHighSpeed_SPI(bool speedValue, DW1000Driver* drv){
-
-  spiStop(drv->spid);
-
-  if (speedValue == FALSE){
-    spiStart(drv->spid, &moduleHalSpiUwbLsConfig);  // low speed spi configuration
-  }
-  else{
-    spiStart(drv->spid, &moduleHalSpiUwbHsConfig); // high speed spi configuration
-  }
-}
-#endif /* (BOARD_DW1000_CONNECTED == true) */
-/** @} */
-
-
-/*===========================================================================*/
-/**
  * @name Low-level drivers
  * @{
  */
@@ -622,17 +576,15 @@ TLC5947Driver moduleLldLedPwm = {
   /* XLAT signal GPIO   */ &moduleGpioLightXlat,
 };
 
-#if (BOARD_DW1000_CONNECTED == true)
+#if (BOARD_BREAKOUT_MODULE == BOARD_BREAKOUT_UWBv10)
+
 DW1000Driver moduleLldDw1000 = {
-  /* SPI driver         */ &MODULE_HAL_SPI_UWB,
-  /* ext interrupt      */ &moduleGpioDw1000Irqn,
-  /* RESET DW1000       */ &moduleGpioDw1000Reset,
+  /* SPI driver     */ &MODULE_HAL_SPI_UWB,
+  /* interrupt GPIO */ &moduleGpioBreakoutIo8,
+  /* reset GPIO     */ &moduleGpioBreakoutIo7,
 };
 
-MIC9404xDriver moduleLldPowerSwitchDw1000 = {
-  /* power enable GPIO  */ &moduleGpioSwVsysEn,
-};
-#endif /* (BOARD_DW1000_CONNECTED == true) */
+#endif /* (BOARD_BREAKOUT_MODULE == BOARD_BREAKOUT_UWBv10) */
 
 /** @} */
 
@@ -696,7 +648,8 @@ static int _testTlc5947ShellCmdCb(BaseSequentialStream* stream, int argc, char*
 }
 AOS_SHELL_COMMAND(moduleTestTlc5947ShellCmd, "test:Lights", _testTlc5947ShellCmdCb);
 
-#if (BOARD_DW1000_CONNECTED == true) || defined(__DOXYGEN__)
+#if (BOARD_BREAKOUT_MODULE == BOARD_BREAKOUT_UWBv10)
+
 /*
  * UwB Driver (DW1000)
  */
@@ -706,7 +659,8 @@ static int _testDw1000ShellCmdCb(BaseSequentialStream* stream, int argc, char* a
   return moduleTestDw1000ShellCb(stream, argc, argv, NULL);
 }
 AOS_SHELL_COMMAND(moduleTestDw1000ShellCmd, "test:DW1000", _testDw1000ShellCmdCb);
-#endif /* (BOARD_DW1000_CONNECTED == true) */
+
+#endif /* (BOARD_BREAKOUT_MODULE == BOARD_BREAKOUT_UWBv10) */
 
 /*
  * entire module
@@ -763,6 +717,12 @@ static int _testAllShellCmdCb(BaseSequentialStream* stream, int argc, char* argv
   status |= moduleTestTlc5947ShellCb(stream, 0, targv, &result_test);
   result_total = aosTestResultAdd(result_total, result_test);
 
+#if (BOARD_BREAKOUT_MODULE == BOARD_BREAKOUT_UWBv10)
+  /* DW1000 (UWB transceiver) */
+  status |= moduleTestDw1000ShellCb(stream, 0, targv, &result_test);
+  result_total = aosTestResultAdd(result_total, result_test);
+#endif /* (BOARD_BREAKOUT_MODULE == BOARD_BREAKOUT_UWBv10) */
+
   // print total result
   chprintf(stream, "\n");
   aosTestResultPrintSummary(stream, &result_total, "entire module");